#!/usr/bin/perl -w

# LSB Test Execution Framework
# Browse for File/Directory Module (choose_file.pl)
#
# Copyright (C) 2007 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':mode';

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

my $what = ($_GET{"what"} or "file");
my $cut_path = ($_GET{"default"} or "/");

# Get rid of relative paths
$cut_path = $SERVER_PARAM{"DOCUMENT_ROOT"}."/$cut_path" if ($cut_path !~ m!^/!);

# Obtain the real path that is closest to the requested one
while (($cut_path ne "") and (!-d $cut_path)) {
	$cut_path =~ s/\/[^\/]*$//;
}
$cut_path = "" if ($cut_path eq "/");

# Convert relative path to absolute
if ($cut_path ne "") {
	chdir($cut_path);
	$cut_path = `pwd`;
	$cut_path =~ s/[\r\n]//g;
	chdir($SERVER_PARAM{"DOCUMENT_ROOT"});
}

my $path = (($cut_path eq "") ? "/" : $cut_path);

print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>Test Results</title>
  <style type="text/css">
	table.main {
		border: 0px solid black;
		border-collapse: collapse;
	}
	table.main td, table.main th {
		border: 1px solid black;
		padding: 4px;
		white-space: nowrap;
	}
	table.main td {
		font-family: monospace;
		font-size: 10pt;
	}
	table.main tr .file_icon {
		border: none;
		background: white center center no-repeat;;
	    padding: 2px;
	}
	a, a:visited {
		color: blue;
	}
	tr.list_item0 {
		background: #e7e7e7;
	}
	tr.list_item1 {
		background: #ffffff;
	}
	tr.clickable:hover {
		background-color: #d0d0ff;
		cursor: pointer;
	}
	td h3 {
		margin-top: 10px;
		margin-bottom: 0px;
	}
  </style>
</head>

<body>

<script language="javascript" type="text/javascript">
// <![CDATA[
// Preload images
var preload_image_names = new Array('open_folder.gif', 'select_active.gif', 'select_inactive.gif');
var preload_images = new Array();
for (var i=0; i<preload_image_names.length; ++i) {
	preload_images[i] = new Image;
	preload_images[i].src = 'images/' + preload_image_names[i];
}

function do_open_file(name) {
	if (opener) {
		var elem = opener.document.getElementById('paths');
		if (elem) {
			var to_add = '$cut_path/' + name + '\\n';
			if (elem.value.lastIndexOf('\\n') != (elem.value.length - 1)) {
				to_add = '\\n' + to_add;
			}
			elem.value += to_add;
		}
		var app_name = opener.document.getElementById('application');
		if (app_name && (app_name.value == '')) {
			app_name.value = name;
		}
	}
	window.close();
}

function show_icon(icon, line) {
	var elem = document.getElementById(line);
	if (elem && ((elem.style.backgroundImage.indexOf('select_') == -1) || (icon != 'open_folder.gif'))) {
		elem.style.backgroundImage = 'url(images/' + icon + ')';
	}
}
// ]]>
</script>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td align="left" width="100%"><h3>Open&nbsp;$what:</h3></td>
    <td><img src="images/environment-spacer.gif" width="10" height="1" border="0" alt="" /></td>
    <td align="right"><h3><a href="tests_help.pl#browse" target="_blank">Help</a></h3></td>
  </tr>
</table>
DATA

my @path_dirs = split(/\//, $path);
my $cur_path = "";
print "<p><a href=\"choose_file.pl?what=$what&amp;default=/\">root</a>";
foreach $dir (@path_dirs) {
	next if (!$dir);
	$cur_path .= "/$dir";
	print " / <a href=\"choose_file.pl?what=$what&amp;default=$cur_path\">$dir</a>";
}
print "</p>";

opendir(CUR_DIR, $path);
my @listing = grep(!/^\.+$/, readdir(CUR_DIR));
#my @listing = split(/\n/, `ls -lap $path`);

print <<DATA;
<table class="main">
  <tr>
    <th class="file_icon"></th>
    <th>Name</th>
    <th>Size</th>
    <th>Date/Time</th>
    <th>Owner</th>
    <th>Attr</th>
  </tr>
DATA

my %file_info = ();
my %dir_info = ();

foreach my $name (@listing) {
	my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = lstat("$cut_path/$name");
	my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($mtime);
	my $date_time = sprintf("%04d-%02d-%02d %02d:%02d", ($year + 1900), ($mon + 1), $mday, $hour, $min);
	my $owner = (getpwuid($uid) or $uid);
	my $group = (getgrgid($gid) or $gid);
	my $lnk_target = readlink("$cut_path/$name");
	my $isdir = (-d "$cut_path/$name");

	my $fmt_mode = "";
	if (($mode & S_IFSOCK) == S_IFSOCK) {
		# Socket
		$fmt_mode = 's';
	}
	elsif (($mode & S_IFLNK) == S_IFLNK) {
		# Symbolic link
		$fmt_mode = 'l';
	}
	elsif (($mode & S_IFREG) == S_IFREG) {
		# Regular file
		$fmt_mode = '-';
	}
	elsif (($mode & S_IFBLK) == S_IFBLK) {
		# Block device
		$fmt_mode = 'b';
	}
	elsif (($mode & S_IFDIR) == S_IFDIR) {
		# Directory
		$fmt_mode = 'd';
	}
	elsif (($mode & S_IFCHR) == S_IFCHR) {
		# Character device
		$fmt_mode = 'c';
	}
	elsif (($mode & S_IFIFO) == S_IFIFO) {
		# FIFO
		$fmt_mode = 'p';
	}
	else {
		$fmt_mode = '-';
	}
	$fmt_mode .= (($mode & S_IRUSR) ? 'r' : '-');
	$fmt_mode .= (($mode & S_IWUSR) ? 'w' : '-');
	$fmt_mode .= (($mode & S_ISUID) ? (($mode & S_IXUSR) ? 's' : 'S') : (($mode & S_IXUSR) ? 'x' : '-'));
	$fmt_mode .= (($mode & S_IRGRP) ? 'r' : '-');
	$fmt_mode .= (($mode & S_IWGRP) ? 'w' : '-');
	$fmt_mode .= (($mode & S_ISGID) ? (($mode & S_IXGRP) ? 's' : 'S') : (($mode & S_IXGRP) ? 'x' : '-'));
	$fmt_mode .= (($mode & S_IROTH) ? 'r' : '-');
	$fmt_mode .= (($mode & S_IWOTH) ? 'w' : '-');
	$fmt_mode .= (($mode & S_ISVTX) ? (($mode & S_IXOTH) ? 't' : 'T') : (($mode & S_IXOTH) ? 'x' : '-'));

	if ($isdir) {
		$dir_info{$name}{"SIZE"} = $size;
		$dir_info{$name}{"DATE_TIME"} = "$date_time";
		$dir_info{$name}{"OWNER"} = "$owner:$group";
		$dir_info{$name}{"ATTR"} = $fmt_mode;
		$dir_info{$name}{"LINK"} = ($lnk_target ? " title=\"Symbolic link to $lnk_target\"" : "");
	}
	else {
		$file_info{$name}{"SIZE"} = $size;
		$file_info{$name}{"DATE_TIME"} = "$date_time";
		$file_info{$name}{"OWNER"} = "$owner:$group";
		$file_info{$name}{"ATTR"} = $fmt_mode;
		$file_info{$name}{"LINK"} = ($lnk_target ? " title=\"Symbolic link to $lnk_target\"" : "");
	}
}

my $odd_line = 0;

if ($what eq "directory") {
	foreach $name (sort keys %dir_info) {
		my $tmp_path = "$cut_path/$name";
		print <<DATA;
  <tr class="list_item$odd_line clickable" onclick="javascript:document.location='choose_file.pl?what=$what&amp;default=$tmp_path';" onmouseover="javascript:show_icon('open_folder.gif', '$name');" onmouseout="javascript:show_icon('environment-spacer.gif', '$name');">
    <td class="file_icon" id="$name"><img src="images/environment-spacer.gif" alt="" width="16" height="16" /></td>
    <td style="width: 20em;"$dir_info{$name}{"LINK"}><a href="#" onclick="javascript:do_open_file('$name'); return false;" onmouseover="javascript:show_icon('select_active.gif', '$name');"><b>$name</b></a></td>
    <td align="right" style="width: 4em;">$dir_info{$name}{"SIZE"}</td>
    <td>$dir_info{$name}{"DATE_TIME"}</td>
    <td>$dir_info{$name}{"OWNER"}</td>
    <td>$dir_info{$name}{"ATTR"}</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
	}

	foreach $name (sort keys %file_info) {
		my $display_name = $name;
		print <<DATA;
  <tr class="list_item$odd_line" onmouseover="javascript:show_icon('select_inactive.gif', '$name');" onmouseout="javascript:show_icon('environment-spacer.gif', '$name');">
    <td class="file_icon" id="$name"><img src="images/environment-spacer.gif" alt="" width="16" height="16" /></td>
    <td style="width: 20em;"$file_info{$name}{"LINK"}>$display_name</td>
    <td align="right" style="width: 4em;">$file_info{$name}{"SIZE"}</td>
    <td>$file_info{$name}{"DATE_TIME"}</td>
    <td>$file_info{$name}{"OWNER"}</td>
    <td>$file_info{$name}{"ATTR"}</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
	}
}
else {
	foreach $name (sort keys %dir_info) {
		my $tmp_path = "$cut_path/$name";
		print <<DATA;
  <tr class="list_item$odd_line clickable" onclick="javascript:document.location='choose_file.pl?what=$what&amp;default=$tmp_path';" onmouseover="javascript:show_icon('open_folder.gif', '$name');" onmouseout="javascript:show_icon('environment-spacer.gif', '$name');">
    <td class="file_icon" id="$name"><img src="images/environment-spacer.gif" alt="" width="16" height="16" /></td>
    <td style="width: 20em;"$dir_info{$name}{"LINK"}><a href="choose_file.pl?what=$what&amp;default=$tmp_path"><b>$name</b></a></td>
    <td align="right" style="width: 4em;">$dir_info{$name}{"SIZE"}</td>
    <td>$dir_info{$name}{"DATE_TIME"}</td>
    <td>$dir_info{$name}{"OWNER"}</td>
    <td>$dir_info{$name}{"ATTR"}</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
	}

	foreach $name (sort keys %file_info) {
		my $display_name = "<b>$name</b>";
		print <<DATA;
  <tr class="list_item$odd_line clickable" onclick="javascript:do_open_file('$name');" onmouseover="javascript:show_icon('select_active.gif', '$name');" onmouseout="javascript:show_icon('environment-spacer.gif', '$name');">
    <td class="file_icon" id="$name"><img src="images/environment-spacer.gif" alt="" width="16" height="16" /></td>
    <td style="width: 20em;"$file_info{$name}{"LINK"}>$display_name</td>
    <td align="right" style="width: 4em;">$file_info{$name}{"SIZE"}</td>
    <td>$file_info{$name}{"DATE_TIME"}</td>
    <td>$file_info{$name}{"OWNER"}</td>
    <td>$file_info{$name}{"ATTR"}</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
	}
}

print <<DATA;
</table>

</body>
</html>
DATA
